VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Logger"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'****************************************************************************
'<comment>
' <summary>
'  Logger module for the RETS IDX Client application that has the
'  subroutines and functions that are used to make calls to display an
'  message to a log file or the debug window.
' </summary>
' <remarks></remarks>
' <author>Jeff Brush - Avantia, Inc.</author>
' <date>2002-11-06</date>
'</comment>
'****************************************************************************
Option Explicit

'****************************************************************************
'<comment>
' <summary>
'  errorLog displays an error message.
' </summary>
' <remarks></remarks>
' <param name="msg">
'  The msg string that is to be displayed
'  transaction.
' </param>
'</comment>
'****************************************************************************
Public Sub errorLog(msg As String)
    displayMessage "ERROR: " & msg
End Sub

'****************************************************************************
'<comment>
' <summary>
'  warnLog displays a warning message.
' </summary>
' <remarks></remarks>
' <param name="msg">
'  The msg string that is to be displayed
'  transaction.
' </param>
'</comment>
'****************************************************************************
Public Sub warnLog(msg As String)
    displayMessage "WARN: " & msg
End Sub

'****************************************************************************
'<comment>
' <summary>
'  infoLog displays an informational message.
' </summary>
' <remarks></remarks>
' <param name="msg">
'  The msg string that is to be displayed
'  transaction.
' </param>
'</comment>
'****************************************************************************
Public Sub infoLog(msg As String)
    displayMessage "INFO: " & msg
End Sub

'****************************************************************************
'<comment>
' <summary>
'  debugLog displays a debug message.
' </summary>
' <remarks></remarks>
' <param name="msg">
'  The msg string that is to be displayed
'  transaction.
' </param>
'</comment>
'****************************************************************************
Public Sub debugLog(msg As String)
    displayMessage "DEBUG: " & msg
End Sub

'****************************************************************************
'<comment>
' <summary>
'  displayMessage directs the message to a display medium
' </summary>
' <remarks></remarks>
' <param name="msg">
'  The msg string that is to be displayed
'  transaction.
' </param>
'</comment>
'****************************************************************************
Private Sub displayMessage(msg As String)
    Debug.Print msg
End Sub

