VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RETSAgentSearchTransaction"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'****************************************************************************
'<comment>
' <summary>
'  RETSAgentSearchTransaction class encapsulates the RETS Agent Search transaction
'  It implements RETSSearchTransaction interface.
'   See the RETSSearchTransaction class for 'inherited' details.
'  It implements RETSTransaction interface.
'   See the RETSTransaction class for 'inherited' details.
' </summary>
' <remarks></remarks>
' <author>Jeff Brush - Avantia, Inc.</author>
' <date>2002-11-06</date>
'</comment>
'****************************************************************************
Option Explicit
Implements RETSSearchTransaction
Implements RETSTransaction

'****************************************************************************
'<comment>
' <summary>
'  The private m_transaction object to which RETSTransactions methods and attributes are delegated.
' </summary>
'</comment>
'****************************************************************************
Private m_transaction As RETSTransaction
'****************************************************************************
'<comment>
' <summary>
'  The private m_searchTransaction object to which RETSSearchTransactions methods and attributes are delegated.
' </summary>
'</comment>
'****************************************************************************
Private m_searchTransaction As New RETSSearchTransaction

'****************************************************************************
'<comment>
' <summary>
'  The initializer for the class. It initializes the searchType and searchClass
'       of the Agent Search transaction.
' </summary>
'</comment>
'****************************************************************************
Private Sub Class_Initialize()

    Set m_transaction = m_searchTransaction

    m_searchTransaction.SearchType = "Agent"
    m_searchTransaction.SearchClass = "Agent"
    
End Sub


'****************************************************************************
'<comment>
' <summary>
'   Gets the transaction property
'  </summary>
' <remarks></remarks>
'</comment>
'****************************************************************************
Public Property Get transaction() As RETSTransaction
    Set transaction = RETSSearchTransaction_transaction
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'   'INHERITED' SearchTransaction Methods
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Property Get RETSSearchTransaction_transaction() As RETSTransaction
    Set RETSSearchTransaction_transaction = m_transaction
End Property

Private Property Get RETSSearchTransaction_searchTransaction() As RETSSearchTransaction
    Set RETSSearchTransaction_searchTransaction = m_searchTransaction
End Property

Private Property Let RETSSearchTransaction_searchClass(RHS As String)
    m_searchTransaction.SearchClass = RHS
End Property

Private Property Get RETSSearchTransaction_searchClass() As String
    RETSSearchTransaction_searchClass = m_searchTransaction.SearchClass
End Property

Private Property Let RETSSearchTransaction_searchCount(RHS As String)
    m_searchTransaction.searchCount = RHS
End Property

Private Property Get RETSSearchTransaction_searchCount() As String
    RETSSearchTransaction_searchCount = m_searchTransaction.searchCount
End Property

Private Property Let RETSSearchTransaction_searchDelimiter(RHS As String)
    m_searchTransaction.searchDelimiter = RHS
End Property

Private Property Get RETSSearchTransaction_searchDelimiter() As String
    RETSSearchTransaction_searchDelimiter = m_searchTransaction.searchDelimiter
End Property

Private Property Let RETSSearchTransaction_searchFormat(RHS As String)
    m_searchTransaction.searchFormat = RHS
End Property

Private Property Get RETSSearchTransaction_searchFormat() As String
    RETSSearchTransaction_searchFormat = m_searchTransaction.searchFormat
End Property

Private Property Let RETSSearchTransaction_searchLimit(RHS As String)
    m_searchTransaction.searchLimit = RHS
End Property

Private Property Get RETSSearchTransaction_searchLimit() As String
    RETSSearchTransaction_searchLimit = m_searchTransaction.searchLimit
End Property

Private Property Let RETSSearchTransaction_searchOffset(RHS As String)
    m_searchTransaction.searchOffset = RHS
End Property

Private Property Get RETSSearchTransaction_searchOffset() As String
    RETSSearchTransaction_searchOffset = m_searchTransaction.searchOffset
End Property

Private Property Let RETSSearchTransaction_searchQuery(RHS As String)
    m_searchTransaction.searchQuery = RHS
End Property

Private Property Get RETSSearchTransaction_searchQuery() As String
    RETSSearchTransaction_searchQuery = m_searchTransaction.searchQuery
End Property

Private Property Let RETSSearchTransaction_searchQueryType(RHS As String)
    m_searchTransaction.searchQueryType = RHS
End Property

Private Property Get RETSSearchTransaction_searchQueryType() As String
    RETSSearchTransaction_searchQueryType = m_searchTransaction.searchQueryType
End Property

Private Property Let RETSSearchTransaction_searchRestrictedIndicator(RHS As String)
    m_searchTransaction.SearchRestrictedIndicator = RHS
End Property

Private Property Get RETSSearchTransaction_searchRestrictedIndicator() As String
    RETSSearchTransaction_searchRestrictedIndicator = m_searchTransaction.SearchRestrictedIndicator
End Property

Private Property Let RETSSearchTransaction_searchSelect(RHS As String)
    m_searchTransaction.searchSelect = RHS
End Property

Private Property Get RETSSearchTransaction_searchSelect() As String
    RETSSearchTransaction_searchSelect = m_searchTransaction.searchSelect
End Property

Private Property Let RETSSearchTransaction_searchStandardNames(RHS As String)
    m_searchTransaction.SearchStandardNames = RHS
End Property

Private Property Get RETSSearchTransaction_searchStandardNames() As String
    RETSSearchTransaction_searchStandardNames = m_searchTransaction.SearchStandardNames
End Property

Private Property Let RETSSearchTransaction_searchType(RHS As String)
    m_searchTransaction.SearchType = RHS
End Property

Private Property Get RETSSearchTransaction_searchType() As String
    RETSSearchTransaction_searchType = m_searchTransaction.SearchType
End Property

Private Property Let RETSSearchTransaction_version(RHS As String)
    m_searchTransaction.version = RHS
End Property

Private Property Get RETSSearchTransaction_version() As String
    RETSSearchTransaction_version = m_searchTransaction.version
End Property


'''''''''''''''''''''''''''''''''''''''''''''''''''''
'   'inherited' transaction methods
'''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Property Get RETSTransaction_capabilityUrls() As Dictionary
    Set RETSTransaction_capabilityUrls = m_transaction.capabilityUrls
End Property

Private Property Set RETSTransaction_capabilityUrls(RHS As Dictionary)
    Set m_transaction.capabilityUrls = RHS
End Property

Private Property Get RETSTransaction_context() As Dictionary
    Set RETSTransaction_context = m_transaction.context
End Property

Private Property Set RETSTransaction_context(aContext As Dictionary)
    Set m_transaction.context = aContext
End Property

Private Property Get RETSTransaction_requestMap() As Dictionary
    Set RETSTransaction_requestMap = m_transaction.requestMap
End Property

Private Property Let RETSTransaction_requestType(RHS As String)
    m_transaction.requestType = RHS
End Property

Private Property Get RETSTransaction_requestType() As String
    RETSTransaction_requestType = m_transaction.requestType
End Property

Private Property Get RETSTransaction_response() As String
    RETSTransaction_response = m_transaction.response
End Property

Private Property Let RETSTransaction_response(RHS As String)
    m_transaction.response = RHS
End Property

Private Property Get RETSTransaction_responseMap() As Dictionary
    Set RETSTransaction_responseMap = m_transaction.responseMap
End Property

Private Property Set RETSTransaction_responseMap(aResponseMap As Dictionary)
    Set m_transaction.responseMap = aResponseMap
End Property

Private Property Let RETSTransaction_responseStatus(RHS As String)
    m_transaction.responseStatus = RHS
End Property

Private Property Get RETSTransaction_responseStatus() As String
    RETSTransaction_responseStatus = m_transaction.responseStatus
End Property

Private Property Get RETSTransaction_responseStatusText() As String
    RETSTransaction_responseStatusText = m_transaction.responseStatusText
End Property

Private Property Let RETSTransaction_responseStatusText(RHS As String)
    m_transaction.responseStatusText = RHS
End Property

Private Sub RETSTransaction_setKeyValuePairs(str As String)
    m_transaction.setKeyValuePairs (str)
End Sub

Private Property Get RETSTransaction_url() As String
    RETSTransaction_url = m_transaction.url
End Property

Private Property Let RETSTransaction_url(aUrl As String)
    m_transaction.url = aUrl
End Property

Private Sub RETSTransaction_Preprocess()
    Call m_transaction.Preprocess
End Sub

Private Sub RETSTransaction_Postprocess()
    Call m_transaction.Postprocess
End Sub

