Attribute VB_Name = "modWinInet"
'==================================================================================
' Name: modWinInet.BAS
' Purpose:
'  WinInet API
'  Windows Internet Programming Interface
'  Copyright (C) 2000 Microsoft Corporation
'  All rights reserved.
'------------------------------------------------
'  THIS CODE AND INFORMATION IS PROVIDED "AS IS"
'  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
'  OR IMPLIED, INCLUDING BUT NOT LIMITED
'  TO THE IMPLIED WARRANTIES OF MERCHANTIBILITY
'  AND/OR FITNESS FOR A PARTICULAR PURPOSE.
'------------------------------------------------
'  Date    - 02/22/2000
'  Source  - http://msdn.microsoft.com/downloads/
'    samples/Internet/networking/vbftpjr/
'    Default.asp
'------------------------------------------------
'  CAUTION - The WinInet FTP API wraps the socket
'    code and most low-level FTP commands and
'    provides a set of much simpler task-oriented
'    APIs that do not require detailed knowledge
'    of FTP protocol. However, there is a chance
'    that some FTP servers use FTP commands not
'    implemented by WinInet. If this happens, you
'    have to use the Microsoft Winsock Control to
'    communicate with the server directly at the
'    protocol level.
'==================================================================================
Option Explicit

Declare Function GetProcessHeap Lib "kernel32" () As Long

Declare Function HeapAlloc Lib "kernel32" ( _
    ByVal hHeap As Long, ByVal dwFlags As Long, _
    ByVal dwBytes As Long) _
    As Long
     
Declare Function HeapFree Lib "kernel32" ( _
    ByVal hHeap As Long, _
    ByVal dwFlags As Long, _
    lpMem As Any) _
    As Long
     
Public Const HEAP_ZERO_MEMORY = &H8
Public Const HEAP_GENERATE_EXCEPTIONS = &H4

Declare Sub CopyMemory1 Lib "kernel32" Alias "RtlMoveMemory" ( _
    hpvDest As Any, _
    ByVal hpvSource As Long, _
    ByVal cbCopy As Long)
          
Declare Sub CopyMemory2 Lib "kernel32" Alias "RtlMoveMemory" ( _
    hpvDest As Long, _
    hpvSource As Any, _
    ByVal cbCopy As Long)

Public Const MAX_PATH = 260
Public Const NO_ERROR = 0
Public Const FILE_ATTRIBUTE_READONLY = &H1
Public Const FILE_ATTRIBUTE_HIDDEN = &H2
Public Const FILE_ATTRIBUTE_SYSTEM = &H4
Public Const FILE_ATTRIBUTE_DIRECTORY = &H10
Public Const FILE_ATTRIBUTE_ARCHIVE = &H20
Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const FILE_ATTRIBUTE_TEMPORARY = &H100
Public Const FILE_ATTRIBUTE_COMPRESSED = &H800
Public Const FILE_ATTRIBUTE_OFFLINE = &H1000


Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type


Public Const ERROR_NO_MORE_FILES = 18

Public Declare Function InternetFindNextFile Lib "wininet.dll" _
    Alias "InternetFindNextFileA" ( _
    ByVal hFind As Long, _
    lpvFindData As WIN32_FIND_DATA) _
    As Long
     
Public Declare Function FtpFindFirstFile Lib "wininet.dll" _
    Alias "FtpFindFirstFileA" ( _
    ByVal hFtpSession As Long, _
    ByVal lpszSearchFile As String, _
    lpFindFileData As WIN32_FIND_DATA, _
    ByVal dwFlags As Long, _
    ByVal dwContent As Long) _
    As Long

Public Declare Function FtpGetFile Lib "wininet.dll" _
    Alias "FtpGetFileA" ( _
    ByVal hFtpSession As Long, _
    ByVal lpszRemoteFile As String, _
    ByVal lpszNewFile As String, _
    ByVal fFailIfExists As Boolean, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Boolean

Public Declare Function FtpPutFile Lib "wininet.dll" _
    Alias "FtpPutFileA" ( _
    ByVal hFtpSession As Long, _
    ByVal lpszLocalFile As String, _
    ByVal lpszRemoteFile As String, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Boolean

Public Declare Function FtpSetCurrentDirectory Lib "wininet.dll" _
    Alias "FtpSetCurrentDirectoryA" ( _
    ByVal hFtpSession As Long, _
    ByVal lpszDirectory As String) _
    As Boolean
     
' Initializes an application's use of the Win32 Internet functions
Public Declare Function InternetOpen Lib "wininet.dll" _
    Alias "InternetOpenA" ( _
    ByVal sAgent As String, _
    ByVal lAccessType As Long, _
    ByVal sProxyName As String, _
    ByVal sProxyBypass As String, _
    ByVal lFlags As Long) _
    As Long

' User agent constant. (User defined string)
Public Const INTERNET_USER_AGENT = "VB WinInet"

' Use registry access settings.
Public Const INTERNET_OPEN_TYPE_PRECONFIG = 0
Public Const INTERNET_OPEN_TYPE_DIRECT = 1
Public Const INTERNET_OPEN_TYPE_PROXY = 3
Public Const INTERNET_INVALID_PORT_NUMBER = 0

Public Const FTP_TRANSFER_TYPE_ASCII = &H1
Public Const FTP_TRANSFER_TYPE_BINARY = &H2
Public Const INTERNET_FLAG_PASSIVE = &H8000000

' Opens a HTTP session for a given site.
Public Declare Function InternetConnect Lib "wininet.dll" _
    Alias "InternetConnectA" ( _
    ByVal hInternetSession As Long, _
    ByVal sServerName As String, _
    ByVal nServerPort As Integer, _
    ByVal sUsername As String, _
    ByVal sPassword As String, _
    ByVal lService As Long, _
    ByVal lFlags As Long, _
    ByVal lContext As Long) _
    As Long
                 
' opens a URL
'Private Declare Function InternetOpenUrl Lib "wininet.dll" _
'() '    Alias "InternetOpenUrlA" ( _
'    ByVal hInternetSession As Long, _
'    ByVal lpszUrl As String, _
'    ByVal lpszHeaders As String, _
'    ByVal dwHeadersLength As Long, _
'    ByVal dwFlags As Long, _
'    ByVal dwContext As Long) _
'    As Long

Public Const ERROR_INTERNET_EXTENDED_ERROR = 12003

Public Declare Function InternetGetLastResponseInfo Lib "wininet.dll" _
    Alias "InternetGetLastResponseInfoA" ( _
    lpdwError As Long, _
    ByVal lpszBuffer As String, _
    lpdwBufferLength As Long) _
    As Boolean

' Number of the TCP/IP port on the server to connect to.
Public Const INTERNET_DEFAULT_FTP_PORT = 21
Public Const INTERNET_DEFAULT_GOPHER_PORT = 70
Public Const INTERNET_DEFAULT_HTTP_PORT = 80
Public Const INTERNET_DEFAULT_HTTPS_PORT = 443
Public Const INTERNET_DEFAULT_SOCKS_PORT = 1080

' Security Ignore Flags, Allow HttpOpenRequest to overide
'  Secure Channel (SSL/PCT) failures of the following types.
Public Const INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTP = &H8000       ' ex: https:' to http://
Public Const INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTPS = &H4000      ' ex: http:' to https://
Public Const INTERNET_FLAG_IGNORE_CERT_DATE_INVALID = &H2000      ' expired X509 Cert.
Public Const INTERNET_FLAG_IGNORE_CERT_CN_INVALID = &H1000        ' bad common name in X509 Cert.
 
' additional flags
Public Const INTERNET_FLAG_SECURE = &H800000               ' use PCT/SSL if applicable (HTTP)
Public Const INTERNET_FLAG_KEEP_CONNECTION = &H400000      ' use keep-alive semantics
Public Const INTERNET_FLAG_NO_AUTO_REDIRECT = &H200000     ' don't handle redirections automatically
Public Const INTERNET_FLAG_READ_PREFETCH = &H100000        ' do background read prefetch
Public Const INTERNET_FLAG_NO_COOKIES = &H80000            ' no automatic cookie handling
Public Const INTERNET_FLAG_NO_AUTH = &H40000               ' no automatic authentication handling
Public Const INTERNET_FLAG_CACHE_IF_NET_FAIL = &H10000     ' return cache file if net request fails
  



Public Const INTERNET_OPTION_CONNECT_TIMEOUT = 2
Public Const INTERNET_OPTION_RECEIVE_TIMEOUT = 6
Public Const INTERNET_OPTION_SEND_TIMEOUT = 5

Public Const INTERNET_OPTION_USERNAME = 28
Public Const INTERNET_OPTION_PASSWORD = 29
Public Const INTERNET_OPTION_PROXY_USERNAME = 43
Public Const INTERNET_OPTION_PROXY_PASSWORD = 44

' Type of service to access.
Public Const INTERNET_SERVICE_FTP = 1
Public Const INTERNET_SERVICE_GOPHER = 2
Public Const INTERNET_SERVICE_HTTP = 3

' Opens an HTTP request handle.
Public Declare Function HttpOpenRequest Lib "wininet.dll" _
    Alias "HttpOpenRequestA" ( _
    ByVal hHttpSession As Long, _
    ByVal sVerb As String, _
    ByVal sObjectName As String, _
    ByVal sVersion As String, _
    ByVal sReferer As String, _
    ByVal something As Long, _
    ByVal lFlags As Long, _
    ByVal lContext As Long) _
    As Long

' Brings the data across the wire even if it is locally cached.
Public Const INTERNET_FLAG_RELOAD = &H80000000
Public Const INTERNET_FLAG_MULTIPART = &H200000

Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000

' Sends the specified request to the HTTP server.
Public Declare Function HttpSendRequest Lib "wininet.dll" _
    Alias "HttpSendRequestA" _
    (ByVal hHttpRequest As Long, _
    ByVal sHeaders As String, _
    ByVal lHeadersLength As Long, _
    ByVal sOptional As String, _
    ByVal lOptionalLength As Long) _
    As Integer

' Queries for information about an HTTP request.
Public Declare Function HttpQueryInfo Lib "wininet.dll" _
    Alias "HttpQueryInfoA" _
    (ByVal hHttpRequest As Long, _
    ByVal lInfoLevel As Long, _
    ByRef sBuffer As Any, _
    ByRef lBufferLength As Long, _
    ByRef lIndex As Long) _
    As Integer

' The possible values for the lInfoLevel parameter include:

Public Const HTTP_QUERY_MIME_VERSION = 0
Public Const HTTP_QUERY_CONTENT_TYPE = 1
Public Const HTTP_QUERY_CONTENT_TRANSFER_ENCODING = 2
Public Const HTTP_QUERY_CONTENT_ID = 3
Public Const HTTP_QUERY_CONTENT_DESCRIPTION = 4
Public Const HTTP_QUERY_CONTENT_LENGTH = 5
Public Const HTTP_QUERY_CONTENT_LANGUAGE = 6
Public Const HTTP_QUERY_ALLOW = 7
Public Const HTTP_QUERY_PUBLIC = 8
Public Const HTTP_QUERY_DATE = 9
Public Const HTTP_QUERY_EXPIRES = 10
Public Const HTTP_QUERY_LAST_MODIFIED = 11
Public Const HTTP_QUERY_MESSAGE_ID = 12
Public Const HTTP_QUERY_URI = 13
Public Const HTTP_QUERY_DERIVED_FROM = 14
Public Const HTTP_QUERY_COST = 15
Public Const HTTP_QUERY_LINK = 16
Public Const HTTP_QUERY_PRAGMA = 17
Public Const HTTP_QUERY_VERSION = 18 '// special: part of status line
Public Const HTTP_QUERY_STATUS_CODE = 19 '// special: part of status line
Public Const HTTP_QUERY_STATUS_TEXT = 20 '// special: part of status line
Public Const HTTP_QUERY_RAW_HEADERS = 21 '// special: all headers as ASCIIZ
Public Const HTTP_QUERY_RAW_HEADERS_CRLF = 22 '// special: all headers
Public Const HTTP_QUERY_CONNECTION = 23
Public Const HTTP_QUERY_ACCEPT = 24
Public Const HTTP_QUERY_ACCEPT_CHARSET = 25
Public Const HTTP_QUERY_ACCEPT_ENCODING = 26
Public Const HTTP_QUERY_ACCEPT_LANGUAGE = 27
Public Const HTTP_QUERY_AUTHORIZATION = 28
Public Const HTTP_QUERY_CONTENT_ENCODING = 29
Public Const HTTP_QUERY_FORWARDED = 30
Public Const HTTP_QUERY_FROM = 31
Public Const HTTP_QUERY_IF_MODIFIED_SINCE = 32
Public Const HTTP_QUERY_LOCATION = 33
Public Const HTTP_QUERY_ORIG_URI = 34
Public Const HTTP_QUERY_REFERER = 35
Public Const HTTP_QUERY_RETRY_AFTER = 36
Public Const HTTP_QUERY_SERVER = 37
Public Const HTTP_QUERY_TITLE = 38
Public Const HTTP_QUERY_USER_AGENT = 39
Public Const HTTP_QUERY_WWW_AUTHENTICATE = 40
Public Const HTTP_QUERY_PROXY_AUTHENTICATE = 41
Public Const HTTP_QUERY_ACCEPT_RANGES = 42
Public Const HTTP_QUERY_SET_COOKIE = 43
Public Const HTTP_QUERY_COOKIE = 44
Public Const HTTP_QUERY_REQUEST_METHOD = 45 '// special: GET/POST etc.
Public Const HTTP_QUERY_RETURN_CODE = 901
Public Const HTTP_QUERY_VERB = 902
Public Const HTTP_QUERY_OBJECT = 903
Public Const HTTP_QUERY_FILE_URL = 904


Public Const HTTP_STATUS_OK = 200
Public Const HTTP_STATUS_DENIED = 401
Public Const HTTP_STATUS_PROXY_AUTH_REQ = 407

Private Const ERROR_INSUFFICIENT_BUFFER = 122

' Add this flag to the about flags to get request header.

Public Const HTTP_QUERY_FLAG_COALESCE = &H10000000      ' Not implemented.
Public Const HTTP_QUERY_FLAG_NUMBER = &H20000000        ' Returns the data as a 32-bit number for headers whose value is a number, such as the status code.
Public Const HTTP_QUERY_FLAG_SYSTEMTIME = &H40000000    ' Returns the header value as a standard Microsoft Win32 SYSTEMTIME structure, which does not require the application to parse the data. Use for headers whose value is a date/time string, such as "Last-Modified-Time".
Public Const HTTP_QUERY_FLAG_REQUEST_HEADERS = &H80000000   ' Queries request headers only.

' // flags for InternetCanonicalizeUrl() and InternetCombineUrl()
Public Enum ICU_Flags
  ICU_NO_ENCODE = &H20000000              ' // Don't convert unsafe characters to escape sequence
  ICU_DECODE = &H10000000                 ' // Convert %XX escape sequences to characters
  ICU_NO_META = &H8000000                 ' // Don't convert .. etc. meta path sequences
  ICU_ENCODE_SPACES_ONLY = &H4000000      ' // Encode spaces only
  ICU_BROWSER_MODE = &H2000000            ' // Special encode/decode rules for browser
End Enum

Private Declare Function InternetCanonicalizeUrl Lib "wininet.dll" _
Alias "InternetCanonicalizeUrlA" ( _
  ByVal lpszUrl As String, _
  ByVal lpszBuffer As String, _
  lpdwBufferLength As Long, _
  ByVal dwFlags As Long) As Long
  
' Reads data from a handle opened by the HttpOpenRequest function.
Public Declare Function InternetReadFile Lib "wininet.dll" ( _
    ByVal hFile As Long, _
    ByVal sBuffer As String, _
    ByVal lNumBytesToRead As Long, _
    lNumberOfBytesRead As Long) _
    As Integer

Public Declare Function InternetWriteFile Lib "wininet.dll" ( _
    ByVal hFile As Long, _
    ByVal sBuffer As String, _
    ByVal lNumberOfBytesToRead As Long, _
    lNumberOfBytesRead As Long) _
    As Integer

Public Declare Function FtpOpenFile Lib "wininet.dll" _
    Alias "FtpOpenFileA" _
    (ByVal hFtpSession As Long, _
    ByVal sFileName As String, _
    ByVal lAccess As Long, _
    ByVal lFlags As Long, _
    ByVal lContext As Long) _
    As Long
         
Public Declare Function FtpDeleteFile Lib "wininet.dll" _
    Alias "FtpDeleteFileA" ( _
    ByVal hFtpSession As Long, _
    ByVal lpszFileName As String) _
    As Boolean
     
Public Declare Function InternetSetOption Lib "wininet.dll" _
    Alias "InternetSetOptionA" ( _
    ByVal hInternet As Long, _
    ByVal lOption As Long, _
    ByRef sBuffer As Any, _
    ByVal lBufferLength As Long) _
    As Integer
     
Public Declare Function InternetSetOptionStr Lib "wininet.dll" _
    Alias "InternetSetOptionA" ( _
    ByVal hInternet As Long, _
    ByVal lOption As Long, _
    ByVal sBuffer As String, _
    ByVal lBufferLength As Long) _
    As Integer

' Closes a single Internet handle or a subtree of Internet handles.
Public Declare Function InternetCloseHandle Lib "wininet.dll" ( _
    ByVal hInet As Long) _
    As Integer

' Queries an Internet option on the specified handle
Public Declare Function InternetQueryOption Lib "wininet.dll" _
    Alias "InternetQueryOptionA" ( _
    ByVal hInternet As Long, _
    ByVal lOption As Long, _
    ByRef sBuffer As Any, _
    ByRef lBufferLength As Long) _
    As Integer

' Returns the version number of Wininet.dll.
Public Const INTERNET_OPTION_VERSION = 40

' Contains the version number of the DLL that contains the Windows Internet
' functions (Wininet.dll). This structure is used when passing the
' INTERNET_OPTION_VERSION flag to the InternetQueryOption function.
Public Type tWinInetDLLVersion
    lMajorVersion As Long
    lMinorVersion As Long
End Type

' Adds one or more HTTP request headers to the HTTP request handle.
Public Declare Function HttpAddRequestHeaders Lib "wininet.dll" _
    Alias "HttpAddRequestHeadersA" ( _
    ByVal hHttpRequest As Long, _
    ByVal sHeaders As String, _
    ByVal lHeadersLength As Long, _
    ByVal lModifiers As Long) _
    As Integer

' Flags to modify the semantics of this function. Can be a combination of these values:

' Adds the header only if it does not already exist; otherwise, an error is returned.
Public Const HTTP_ADDREQ_FLAG_ADD_IF_NEW = &H10000000

' Adds the header if it does not exist. Used with REPLACE.
Public Const HTTP_ADDREQ_FLAG_ADD = &H20000000

' Replaces or removes a header. If the header value is empty and the header is found,
' it is removed. If not empty, the header value is replaced
Public Const HTTP_ADDREQ_FLAG_REPLACE = &H80000000


Private m_SafeChar(0 To 255) As Boolean
' Set m_SafeChar(i) = True for characters that
' do not need protection.
Private Sub SetSafeChars()
Static done_before As Boolean
Dim i As Integer

    If done_before Then Exit Sub
    done_before = True

    For i = 0 To 47
        m_SafeChar(i) = False
    Next i
    For i = 48 To 57
        m_SafeChar(i) = True
    Next i
    For i = 58 To 64
        m_SafeChar(i) = False
    Next i
    For i = 65 To 90
        m_SafeChar(i) = True
    Next i
    For i = 91 To 96
        m_SafeChar(i) = False
    Next i
    For i = 97 To 122
        m_SafeChar(i) = True
    Next i
    For i = 123 To 255
        m_SafeChar(i) = False
    Next i
End Sub
' Return a URL safe encoding of txt.
Public Function URLEncode(ByVal txt As String) As String
Dim i As Integer
Dim ch As String
Dim ch_asc As Integer
Dim result As String

    SetSafeChars

    result = ""
    For i = 1 To Len(txt)
        ' Translate the next character.
        ch = Mid$(txt, i, 1)
        ch_asc = Asc(ch)
        If ch_asc = vbKeySpace Then
            ' Use a plus.
            result = result & "+"
        ElseIf m_SafeChar(ch_asc) Then
            ' Use the character.
            result = result & ch
        Else
            ' Convert the character to hex.
            result = result & "%" & Right$("0" & Hex$(ch_asc), 2)
        End If
    Next i

    URLEncode = result
End Function
